"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../util");
var decode = function (msg) {
    var affectedPaths = util_1.searchAll(msg, "affectedPaths") || [];
    return [affectedPaths];
};
var encode = function (_a) {
    var paths = _a.paths, allowPartial = _a.allowPartial;
    return ({
        lookup: "Msg",
        header: {
            msgId: util_1.uniq("DELETE@"),
            msgType: "DELETE",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                delete: {
                    objPaths: Array.isArray(paths) ? paths : [paths],
                    allowPartial: allowPartial || false
                },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode
};
