"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var decode = function (msg) {
    var results = util.search(msg, "reqPathResults");
    return [results];
};
var encode = function (_a) {
    var paths = _a.paths, _b = _a.opts, opts = _b === void 0 ? {} : _b;
    return ({
        lookup: "Msg",
        header: {
            msgId: util.uniq("GET_INSTANCES@"),
            msgType: "GET_INSTANCES",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                getInstances: {
                    objPaths: Array.isArray(paths) ? paths : [paths],
                    firstLevelOnly: opts.firstLevelOnly || false
                },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode
};
