"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../util");
var decode = function (msg) { return [msg]; };
var encode = function (_a) {
    var subscriptionId = _a.subscriptionId, msgId = _a.msgId;
    return ({
        lookup: "Msg",
        header: {
            msgId: msgId || util_1.uniq("NOTIFY_RESP@"),
            msgType: "NOTIFY_RESP",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            response: {
                lookup: "Request",
                notifyResp: { subscriptionId: subscriptionId },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode,
};
