"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var decode = function (msg) {
    var data = util.searchAll(msg, "operationResults");
    var output = util.search(data, 'reqOutputArgs');
    if (output)
        return [output];
    if (data && data.length === 1)
        return [util.unflatten(data[0])];
    var unflattened = data.map(function (v) { return util.unflatten(v); });
    return [unflattened];
};
var encode = function (_a) {
    var path = _a.path, input = _a.input, id = _a.id, resp = _a.resp, commandKey = _a.commandKey;
    return ({
        lookup: "Msg",
        header: {
            msgId: id,
            msgType: "OPERATE",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                operate: {
                    command: path,
                    commandKey: commandKey || "",
                    sendResp: resp,
                    inputArgs: input || {},
                },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode
};
