"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var splitReference = function (s) { return s.split(","); };
var isReference = function (s) { return s.startsWith("Device."); };
var addDot = function (s) { return (s.endsWith(".") ? s : s + "."); };
var resolveReferences = function (message, call, level) { return __awaiter(void 0, void 0, void 0, function () {
    var msg, msg, _loop_1, _i, _a, _b, key, val;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (level === 0 || !["string", "object"].includes(typeof message))
                    return [2 /*return*/, message];
                if (!(typeof message === "string")) return [3 /*break*/, 3];
                return [4 /*yield*/, call("GET", { paths: splitReference(message).map(addDot) }).catch(function () { return message; })];
            case 1:
                msg = _c.sent();
                return [4 /*yield*/, resolveReferences(msg, call, level - 1)];
            case 2: return [2 /*return*/, _c.sent()];
            case 3:
                if (!(typeof message === "object")) return [3 /*break*/, 8];
                msg = Array.isArray(message) ? __spreadArray([], message) : __assign({}, message);
                _loop_1 = function (key, val) {
                    var item, _d, _e, _f, _g;
                    return __generator(this, function (_h) {
                        switch (_h.label) {
                            case 0:
                                if (!(typeof val === "string" && isReference(val))) return [3 /*break*/, 3];
                                return [4 /*yield*/, call("GET", { paths: splitReference(val).map(addDot) }).catch(function () { return val; })];
                            case 1:
                                item = _h.sent();
                                _d = msg;
                                _e = key;
                                return [4 /*yield*/, resolveReferences(item, call, level - 1)];
                            case 2:
                                _d[_e] = _h.sent();
                                return [3 /*break*/, 5];
                            case 3:
                                if (!(typeof val === "object")) return [3 /*break*/, 5];
                                _f = msg;
                                _g = key;
                                return [4 /*yield*/, resolveReferences(msg[key], call, level)];
                            case 4:
                                _f[_g] = _h.sent();
                                _h.label = 5;
                            case 5: return [2 /*return*/];
                        }
                    });
                };
                _i = 0, _a = Object.entries(message);
                _c.label = 4;
            case 4:
                if (!(_i < _a.length)) return [3 /*break*/, 7];
                _b = _a[_i], key = _b[0], val = _b[1];
                return [5 /*yield**/, _loop_1(key, val)];
            case 5:
                _c.sent();
                _c.label = 6;
            case 6:
                _i++;
                return [3 /*break*/, 4];
            case 7: return [2 /*return*/, msg];
            case 8: return [2 /*return*/, message];
        }
    });
}); };
var make = function (call) { return function (msg, level) { return resolveReferences(msg, call, level || 1); }; };
exports.default = {
    name: "resolve",
    make: make
};
