import * as util from "../util.js";
const decode = (msg) => {
const results = util.search(msg, "reqObjResults");
return [results];
};
const encode = ({ paths, opts = {} }) => ({
lookup: "Msg",
header: {
msgId: util.uniq("GET_SUPPORTED_DM@"),
msgType: "GET_SUPPORTED_DM",
lookup: "Header",
},
body: {
lookup: "Body",
request: {
lookup: "Request",
getSupportedDm: {
objPaths: Array.isArray(paths) ? paths : [paths],
firstLevelOnly: opts.firstLevelOnly || false,
returnCommands: opts.returnCommands || false,
returnEvents: opts.returnEvents || false,
returnParams: opts.returnParams || false,
},
},
},
});
export default {
decode,
encode
};
