import { CommandType, DecodeOptions, USPSession } from "../types";
export declare const isDigit: (v: any) => boolean;
export declare const unflatten: (obj: any) => {};
export declare const search: (obj: any, key: string) => any;
export declare const searchParent: (obj: any, key: string) => Record<string, any> | undefined;
export declare const convertToNestedObject: (arr: any[]) => {};
export declare const hasMultipleIndexes: (arr: string[], pathSplit: string[]) => boolean;
export declare const searchAll: (obj: any, key: string) => any[];
export declare const extractCommand: (msg: {
    [key: string]: any;
}) => CommandType | undefined;
/** Unwraps object with single key */
export declare const unwrapObject: (data: any) => any;
/** Unwraps array with single item */
export declare const unwrapArray: (arr: any) => any;
export declare const isEmptyObject: (obj: any) => boolean;
export declare const isEmpty: (v: any) => boolean;
export declare function makeBuffer(rootRecord: any, payload: any, version: string, options: Record<string, string>, sessionOptions: USPSession, useSession: boolean): any;
export declare const uniq: (initial?: string | undefined) => string;
export declare const parseID: (msg: any) => any;
export declare const processGetResult: (reqPathResults: PathResult[], decodeOptions?: DecodeOptions | undefined) => any;
export declare type PathResult = {
    requestedPath: string;
    resolvedPathResults?: {
        resolvedPath: string;
        resultParams: {
            key: string;
        };
    }[];
};
export declare enum ResponseType {
    Property = "Property",
    PropertyList = "PropertyList",
    Object = "Object",
    ObjectList = "ObjectList"
}
