"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var decode = function (msg, decodeOptions) {
    var reqPathResults = util.search(msg, "reqPathResults");
    if (decodeOptions === null || decodeOptions === void 0 ? void 0 : decodeOptions.raw)
        return [reqPathResults];
    if (reqPathResults) {
        return [
            util.processGetResult(reqPathResults, decodeOptions),
        ];
    }
    return [null];
};
var encode = function (_a) {
    var paths = _a.paths, options = _a.options;
    return ({
        lookup: "Msg",
        header: {
            msgId: util.uniq("GET@"),
            msgType: "GET",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                get: __assign({ paramPaths: Array.isArray(paths) ? paths : [paths] }, (Number.isInteger(options === null || options === void 0 ? void 0 : options.max_depth)
                    ? { maxDepth: options.max_depth }
                    : {})),
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode,
};
