"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_1 = __importDefault(require("./get"));
var set_1 = __importDefault(require("./set"));
var add_1 = __importDefault(require("./add"));
var del_1 = __importDefault(require("./del"));
var operate_1 = __importDefault(require("./operate"));
var supported_1 = __importDefault(require("./supported"));
var proto_1 = __importDefault(require("./proto"));
var instances_1 = __importDefault(require("./instances"));
var notify_1 = __importDefault(require("./notify"));
var notifyResp_1 = __importDefault(require("./notifyResp"));
exports.default = {
    GET: get_1.default,
    GET_INSTANCES: instances_1.default,
    GET_SUPPORTED_DM: supported_1.default,
    GET_SUPPORTED_PROTO: proto_1.default,
    NOTIFY: notify_1.default,
    NOTIFY_RESP: notifyResp_1.default,
    ADD: add_1.default,
    DELETE: del_1.default,
    OPERATE: operate_1.default,
    SET: set_1.default,
};
