"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var parseInfo = function (key, data) {
    return util.unflatten(util.search(data, key === "operComplete" ? "outputArgs" : key) || {});
};
var decode = function (msg) {
    var parent = util.searchParent(msg, "subscriptionId");
    if (parent) {
        var id = parent.subscriptionId;
        var relField = Object.keys(parent).find(function (k) { return k !== "subscriptionId" && k !== "sendResp"; });
        return id && relField
            ? [parseInfo(relField, msg), id, null]
            : [null, id, null];
    }
    return [null];
};
var encode = function (_a) {
    var sendResp = _a.sendResp, subscriptionId = _a.subscriptionId, rest = __rest(_a, ["sendResp", "subscriptionId"]);
    return ({
        lookup: "Msg",
        header: {
            msgId: util.uniq("NOTIFY@"),
            msgType: "GET",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                notify: __assign({ subscriptionId: subscriptionId,
                    sendResp: sendResp }, rest),
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode,
};
