declare namespace _default {
    namespace nested {
        namespace usp_record {
            export namespace nested_1 {
                namespace Record {
                    export namespace oneofs {
                        namespace recordType {
                            const oneof: string[];
                        }
                    }
                    export namespace fields {
                        namespace version {
                            const type: string;
                            const id: number;
                        }
                        namespace toId {
                            const type_1: string;
                            export { type_1 as type };
                            const id_1: number;
                            export { id_1 as id };
                        }
                        namespace fromId {
                            const type_2: string;
                            export { type_2 as type };
                            const id_2: number;
                            export { id_2 as id };
                        }
                        namespace payloadSecurity {
                            const type_3: string;
                            export { type_3 as type };
                            const id_3: number;
                            export { id_3 as id };
                        }
                        namespace macSignature {
                            const type_4: string;
                            export { type_4 as type };
                            const id_4: number;
                            export { id_4 as id };
                        }
                        namespace senderCert {
                            const type_5: string;
                            export { type_5 as type };
                            const id_5: number;
                            export { id_5 as id };
                        }
                        namespace noSessionContext {
                            const type_6: string;
                            export { type_6 as type };
                            const id_6: number;
                            export { id_6 as id };
                        }
                        namespace sessionContext {
                            const type_7: string;
                            export { type_7 as type };
                            const id_7: number;
                            export { id_7 as id };
                        }
                        namespace websocketConnect {
                            const type_8: string;
                            export { type_8 as type };
                            const id_8: number;
                            export { id_8 as id };
                        }
                        namespace mqttConnect {
                            const type_9: string;
                            export { type_9 as type };
                            const id_9: number;
                            export { id_9 as id };
                        }
                        namespace stompConnect {
                            const type_10: string;
                            export { type_10 as type };
                            const id_10: number;
                            export { id_10 as id };
                        }
                        namespace disconnect {
                            const type_11: string;
                            export { type_11 as type };
                            const id_11: number;
                            export { id_11 as id };
                        }
                    }
                    export namespace nested_2 {
                        namespace PayloadSecurity {
                            namespace values {
                                const PLAINTEXT: number;
                                const TLS12: number;
                            }
                        }
                    }
                    export { nested_2 as nested };
                }
                namespace NoSessionContextRecord {
                    export namespace fields_1 {
                        namespace payload {
                            const type_12: string;
                            export { type_12 as type };
                            const id_12: number;
                            export { id_12 as id };
                        }
                    }
                    export { fields_1 as fields };
                }
                namespace SessionContextRecord {
                    export namespace fields_2 {
                        export namespace sessionId {
                            const type_13: string;
                            export { type_13 as type };
                            const id_13: number;
                            export { id_13 as id };
                        }
                        export namespace sequenceId {
                            const type_14: string;
                            export { type_14 as type };
                            const id_14: number;
                            export { id_14 as id };
                        }
                        export namespace expectedId {
                            const type_15: string;
                            export { type_15 as type };
                            const id_15: number;
                            export { id_15 as id };
                        }
                        export namespace retransmitId {
                            const type_16: string;
                            export { type_16 as type };
                            const id_16: number;
                            export { id_16 as id };
                        }
                        export namespace payloadSarState {
                            const type_17: string;
                            export { type_17 as type };
                            const id_17: number;
                            export { id_17 as id };
                        }
                        export namespace payloadrecSarState {
                            const type_18: string;
                            export { type_18 as type };
                            const id_18: number;
                            export { id_18 as id };
                        }
                        export namespace payload_1 {
                            export const rule: string;
                            const type_19: string;
                            export { type_19 as type };
                            const id_19: number;
                            export { id_19 as id };
                        }
                        export { payload_1 as payload };
                    }
                    export { fields_2 as fields };
                    export namespace nested_3 {
                        namespace PayloadSARState {
                            export namespace values_1 {
                                const NONE: number;
                                const BEGIN: number;
                                const INPROCESS: number;
                                const COMPLETE: number;
                            }
                            export { values_1 as values };
                        }
                    }
                    export { nested_3 as nested };
                }
                namespace WebSocketConnectRecord {
                    const fields_3: {};
                    export { fields_3 as fields };
                }
                namespace MQTTConnectRecord {
                    export namespace fields_4 {
                        export namespace version_1 {
                            const type_20: string;
                            export { type_20 as type };
                            const id_20: number;
                            export { id_20 as id };
                        }
                        export { version_1 as version };
                        export namespace subscribedTopic {
                            const type_21: string;
                            export { type_21 as type };
                            const id_21: number;
                            export { id_21 as id };
                        }
                    }
                    export { fields_4 as fields };
                    export namespace nested_4 {
                        namespace MQTTVersion {
                            export namespace values_2 {
                                const V3_1_1: number;
                                const V5: number;
                            }
                            export { values_2 as values };
                        }
                    }
                    export { nested_4 as nested };
                }
                namespace STOMPConnectRecord {
                    export namespace fields_5 {
                        export namespace version_2 {
                            const type_22: string;
                            export { type_22 as type };
                            const id_22: number;
                            export { id_22 as id };
                        }
                        export { version_2 as version };
                        export namespace subscribedDestination {
                            const type_23: string;
                            export { type_23 as type };
                            const id_23: number;
                            export { id_23 as id };
                        }
                    }
                    export { fields_5 as fields };
                    export namespace nested_5 {
                        namespace STOMPVersion {
                            export namespace values_3 {
                                const V1_2: number;
                            }
                            export { values_3 as values };
                        }
                    }
                    export { nested_5 as nested };
                }
                namespace DisconnectRecord {
                    export namespace fields_6 {
                        namespace reason {
                            const type_24: string;
                            export { type_24 as type };
                            const id_24: number;
                            export { id_24 as id };
                        }
                        namespace reasonCode {
                            const type_25: string;
                            export { type_25 as type };
                            const id_25: number;
                            export { id_25 as id };
                        }
                    }
                    export { fields_6 as fields };
                }
            }
            export { nested_1 as nested };
        }
    }
}
export default _default;
