declare namespace _default {
    namespace nested {
        namespace usp {
            export namespace nested_1 {
                namespace Msg {
                    namespace fields {
                        namespace header {
                            const type: string;
                            const id: number;
                        }
                        namespace body {
                            const type_1: string;
                            export { type_1 as type };
                            const id_1: number;
                            export { id_1 as id };
                        }
                    }
                }
                namespace Header {
                    export namespace fields_1 {
                        namespace msgId {
                            const type_2: string;
                            export { type_2 as type };
                            const id_2: number;
                            export { id_2 as id };
                        }
                        namespace msgType {
                            const type_3: string;
                            export { type_3 as type };
                            const id_3: number;
                            export { id_3 as id };
                        }
                    }
                    export { fields_1 as fields };
                    export namespace nested_2 {
                        namespace MsgType {
                            namespace values {
                                const ERROR: number;
                                const GET: number;
                                const GET_RESP: number;
                                const NOTIFY: number;
                                const SET: number;
                                const SET_RESP: number;
                                const OPERATE: number;
                                const OPERATE_RESP: number;
                                const ADD: number;
                                const ADD_RESP: number;
                                const DELETE: number;
                                const DELETE_RESP: number;
                                const GET_SUPPORTED_DM: number;
                                const GET_SUPPORTED_DM_RESP: number;
                                const GET_INSTANCES: number;
                                const GET_INSTANCES_RESP: number;
                                const NOTIFY_RESP: number;
                                const GET_SUPPORTED_PROTO: number;
                                const GET_SUPPORTED_PROTO_RESP: number;
                            }
                        }
                    }
                    export { nested_2 as nested };
                }
                namespace Body {
                    export namespace oneofs {
                        namespace msgBody {
                            const oneof: string[];
                        }
                    }
                    export namespace fields_2 {
                        namespace request {
                            const type_4: string;
                            export { type_4 as type };
                            const id_4: number;
                            export { id_4 as id };
                        }
                        namespace response {
                            const type_5: string;
                            export { type_5 as type };
                            const id_5: number;
                            export { id_5 as id };
                        }
                        namespace error {
                            const type_6: string;
                            export { type_6 as type };
                            const id_6: number;
                            export { id_6 as id };
                        }
                    }
                    export { fields_2 as fields };
                }
                namespace Request {
                    export namespace oneofs_1 {
                        namespace reqType {
                            const oneof_1: string[];
                            export { oneof_1 as oneof };
                        }
                    }
                    export { oneofs_1 as oneofs };
                    export namespace fields_3 {
                        export namespace get {
                            const type_7: string;
                            export { type_7 as type };
                            const id_7: number;
                            export { id_7 as id };
                        }
                        export namespace getSupportedDm {
                            const type_8: string;
                            export { type_8 as type };
                            const id_8: number;
                            export { id_8 as id };
                        }
                        export namespace getInstances {
                            const type_9: string;
                            export { type_9 as type };
                            const id_9: number;
                            export { id_9 as id };
                        }
                        export namespace set {
                            const type_10: string;
                            export { type_10 as type };
                            const id_10: number;
                            export { id_10 as id };
                        }
                        export namespace add {
                            const type_11: string;
                            export { type_11 as type };
                            const id_11: number;
                            export { id_11 as id };
                        }
                        export namespace _delete {
                            const type_12: string;
                            export { type_12 as type };
                            const id_12: number;
                            export { id_12 as id };
                        }
                        export { _delete as delete };
                        export namespace operate {
                            const type_13: string;
                            export { type_13 as type };
                            const id_13: number;
                            export { id_13 as id };
                        }
                        export namespace notify {
                            const type_14: string;
                            export { type_14 as type };
                            const id_14: number;
                            export { id_14 as id };
                        }
                        export namespace getSupportedProtocol {
                            const type_15: string;
                            export { type_15 as type };
                            const id_15: number;
                            export { id_15 as id };
                        }
                    }
                    export { fields_3 as fields };
                }
                namespace Response {
                    export namespace oneofs_2 {
                        namespace respType {
                            const oneof_2: string[];
                            export { oneof_2 as oneof };
                        }
                    }
                    export { oneofs_2 as oneofs };
                    export namespace fields_4 {
                        namespace getResp {
                            const type_16: string;
                            export { type_16 as type };
                            const id_16: number;
                            export { id_16 as id };
                        }
                        namespace getSupportedDmResp {
                            const type_17: string;
                            export { type_17 as type };
                            const id_17: number;
                            export { id_17 as id };
                        }
                        namespace getInstancesResp {
                            const type_18: string;
                            export { type_18 as type };
                            const id_18: number;
                            export { id_18 as id };
                        }
                        namespace setResp {
                            const type_19: string;
                            export { type_19 as type };
                            const id_19: number;
                            export { id_19 as id };
                        }
                        namespace addResp {
                            const type_20: string;
                            export { type_20 as type };
                            const id_20: number;
                            export { id_20 as id };
                        }
                        namespace deleteResp {
                            const type_21: string;
                            export { type_21 as type };
                            const id_21: number;
                            export { id_21 as id };
                        }
                        namespace operateResp {
                            const type_22: string;
                            export { type_22 as type };
                            const id_22: number;
                            export { id_22 as id };
                        }
                        namespace notifyResp {
                            const type_23: string;
                            export { type_23 as type };
                            const id_23: number;
                            export { id_23 as id };
                        }
                        namespace getSupportedProtocolResp {
                            const type_24: string;
                            export { type_24 as type };
                            const id_24: number;
                            export { id_24 as id };
                        }
                    }
                    export { fields_4 as fields };
                }
                namespace Error {
                    export namespace fields_5 {
                        namespace errCode {
                            const type_25: string;
                            export { type_25 as type };
                            const id_25: number;
                            export { id_25 as id };
                        }
                        namespace errMsg {
                            const type_26: string;
                            export { type_26 as type };
                            const id_26: number;
                            export { id_26 as id };
                        }
                        namespace paramErrs {
                            export const rule: string;
                            const type_27: string;
                            export { type_27 as type };
                            const id_27: number;
                            export { id_27 as id };
                        }
                    }
                    export { fields_5 as fields };
                    export namespace nested_3 {
                        namespace ParamError {
                            export namespace fields_6 {
                                export namespace paramPath {
                                    const type_28: string;
                                    export { type_28 as type };
                                    const id_28: number;
                                    export { id_28 as id };
                                }
                                export namespace errCode_1 {
                                    const type_29: string;
                                    export { type_29 as type };
                                    const id_29: number;
                                    export { id_29 as id };
                                }
                                export { errCode_1 as errCode };
                                export namespace errMsg_1 {
                                    const type_30: string;
                                    export { type_30 as type };
                                    const id_30: number;
                                    export { id_30 as id };
                                }
                                export { errMsg_1 as errMsg };
                            }
                            export { fields_6 as fields };
                        }
                    }
                    export { nested_3 as nested };
                }
                namespace Get {
                    export namespace fields_7 {
                        namespace paramPaths {
                            const rule_1: string;
                            export { rule_1 as rule };
                            const type_31: string;
                            export { type_31 as type };
                            const id_31: number;
                            export { id_31 as id };
                        }
                        namespace maxDepth {
                            const type_32: string;
                            export { type_32 as type };
                            const id_32: number;
                            export { id_32 as id };
                        }
                    }
                    export { fields_7 as fields };
                }
                namespace GetResp {
                    export namespace fields_8 {
                        namespace reqPathResults {
                            const rule_2: string;
                            export { rule_2 as rule };
                            const type_33: string;
                            export { type_33 as type };
                            const id_33: number;
                            export { id_33 as id };
                        }
                    }
                    export { fields_8 as fields };
                    export namespace nested_4 {
                        namespace RequestedPathResult {
                            export namespace fields_9 {
                                export namespace requestedPath {
                                    const type_34: string;
                                    export { type_34 as type };
                                    const id_34: number;
                                    export { id_34 as id };
                                }
                                export namespace errCode_2 {
                                    const type_35: string;
                                    export { type_35 as type };
                                    const id_35: number;
                                    export { id_35 as id };
                                }
                                export { errCode_2 as errCode };
                                export namespace errMsg_2 {
                                    const type_36: string;
                                    export { type_36 as type };
                                    const id_36: number;
                                    export { id_36 as id };
                                }
                                export { errMsg_2 as errMsg };
                                export namespace resolvedPathResults {
                                    const rule_3: string;
                                    export { rule_3 as rule };
                                    const type_37: string;
                                    export { type_37 as type };
                                    const id_37: number;
                                    export { id_37 as id };
                                }
                            }
                            export { fields_9 as fields };
                        }
                        namespace ResolvedPathResult {
                            export namespace fields_10 {
                                namespace resolvedPath {
                                    const type_38: string;
                                    export { type_38 as type };
                                    const id_38: number;
                                    export { id_38 as id };
                                }
                                namespace resultParams {
                                    export const keyType: string;
                                    const type_39: string;
                                    export { type_39 as type };
                                    const id_39: number;
                                    export { id_39 as id };
                                }
                            }
                            export { fields_10 as fields };
                        }
                    }
                    export { nested_4 as nested };
                }
                namespace GetSupportedDM {
                    export namespace fields_11 {
                        namespace objPaths {
                            const rule_4: string;
                            export { rule_4 as rule };
                            const type_40: string;
                            export { type_40 as type };
                            const id_40: number;
                            export { id_40 as id };
                        }
                        namespace firstLevelOnly {
                            const type_41: string;
                            export { type_41 as type };
                            const id_41: number;
                            export { id_41 as id };
                        }
                        namespace returnCommands {
                            const type_42: string;
                            export { type_42 as type };
                            const id_42: number;
                            export { id_42 as id };
                        }
                        namespace returnEvents {
                            const type_43: string;
                            export { type_43 as type };
                            const id_43: number;
                            export { id_43 as id };
                        }
                        namespace returnParams {
                            const type_44: string;
                            export { type_44 as type };
                            const id_44: number;
                            export { id_44 as id };
                        }
                    }
                    export { fields_11 as fields };
                }
                namespace GetSupportedDMResp {
                    export namespace fields_12 {
                        namespace reqObjResults {
                            const rule_5: string;
                            export { rule_5 as rule };
                            const type_45: string;
                            export { type_45 as type };
                            const id_45: number;
                            export { id_45 as id };
                        }
                    }
                    export { fields_12 as fields };
                    export namespace nested_5 {
                        namespace RequestedObjectResult {
                            export namespace fields_13 {
                                export namespace reqObjPath {
                                    const type_46: string;
                                    export { type_46 as type };
                                    const id_46: number;
                                    export { id_46 as id };
                                }
                                export namespace errCode_3 {
                                    const type_47: string;
                                    export { type_47 as type };
                                    const id_47: number;
                                    export { id_47 as id };
                                }
                                export { errCode_3 as errCode };
                                export namespace errMsg_3 {
                                    const type_48: string;
                                    export { type_48 as type };
                                    const id_48: number;
                                    export { id_48 as id };
                                }
                                export { errMsg_3 as errMsg };
                                export namespace dataModelInstUri {
                                    const type_49: string;
                                    export { type_49 as type };
                                    const id_49: number;
                                    export { id_49 as id };
                                }
                                export namespace supportedObjs {
                                    const rule_6: string;
                                    export { rule_6 as rule };
                                    const type_50: string;
                                    export { type_50 as type };
                                    const id_50: number;
                                    export { id_50 as id };
                                }
                            }
                            export { fields_13 as fields };
                        }
                        namespace SupportedObjectResult {
                            export namespace fields_14 {
                                namespace supportedObjPath {
                                    const type_51: string;
                                    export { type_51 as type };
                                    const id_51: number;
                                    export { id_51 as id };
                                }
                                namespace access {
                                    const type_52: string;
                                    export { type_52 as type };
                                    const id_52: number;
                                    export { id_52 as id };
                                }
                                namespace isMultiInstance {
                                    const type_53: string;
                                    export { type_53 as type };
                                    const id_53: number;
                                    export { id_53 as id };
                                }
                                namespace supportedCommands {
                                    const rule_7: string;
                                    export { rule_7 as rule };
                                    const type_54: string;
                                    export { type_54 as type };
                                    const id_54: number;
                                    export { id_54 as id };
                                }
                                namespace supportedEvents {
                                    const rule_8: string;
                                    export { rule_8 as rule };
                                    const type_55: string;
                                    export { type_55 as type };
                                    const id_55: number;
                                    export { id_55 as id };
                                }
                                namespace supportedParams {
                                    const rule_9: string;
                                    export { rule_9 as rule };
                                    const type_56: string;
                                    export { type_56 as type };
                                    const id_56: number;
                                    export { id_56 as id };
                                }
                                namespace divergentPaths {
                                    const rule_10: string;
                                    export { rule_10 as rule };
                                    const type_57: string;
                                    export { type_57 as type };
                                    const id_57: number;
                                    export { id_57 as id };
                                }
                            }
                            export { fields_14 as fields };
                        }
                        namespace SupportedParamResult {
                            export namespace fields_15 {
                                export namespace paramName {
                                    const type_58: string;
                                    export { type_58 as type };
                                    const id_58: number;
                                    export { id_58 as id };
                                }
                                export namespace access_1 {
                                    const type_59: string;
                                    export { type_59 as type };
                                    const id_59: number;
                                    export { id_59 as id };
                                }
                                export { access_1 as access };
                                export namespace valueType {
                                    const type_60: string;
                                    export { type_60 as type };
                                    const id_60: number;
                                    export { id_60 as id };
                                }
                                export namespace valueChange {
                                    const type_61: string;
                                    export { type_61 as type };
                                    const id_61: number;
                                    export { id_61 as id };
                                }
                            }
                            export { fields_15 as fields };
                        }
                        namespace SupportedCommandResult {
                            export namespace fields_16 {
                                namespace commandName {
                                    const type_62: string;
                                    export { type_62 as type };
                                    const id_62: number;
                                    export { id_62 as id };
                                }
                                namespace inputArgNames {
                                    const rule_11: string;
                                    export { rule_11 as rule };
                                    const type_63: string;
                                    export { type_63 as type };
                                    const id_63: number;
                                    export { id_63 as id };
                                }
                                namespace outputArgNames {
                                    const rule_12: string;
                                    export { rule_12 as rule };
                                    const type_64: string;
                                    export { type_64 as type };
                                    const id_64: number;
                                    export { id_64 as id };
                                }
                                namespace commandType {
                                    const type_65: string;
                                    export { type_65 as type };
                                    const id_65: number;
                                    export { id_65 as id };
                                }
                            }
                            export { fields_16 as fields };
                        }
                        namespace SupportedEventResult {
                            export namespace fields_17 {
                                namespace eventName {
                                    const type_66: string;
                                    export { type_66 as type };
                                    const id_66: number;
                                    export { id_66 as id };
                                }
                                namespace argNames {
                                    const rule_13: string;
                                    export { rule_13 as rule };
                                    const type_67: string;
                                    export { type_67 as type };
                                    const id_67: number;
                                    export { id_67 as id };
                                }
                            }
                            export { fields_17 as fields };
                        }
                        namespace ParamAccessType {
                            export namespace values_1 {
                                const PARAM_READ_ONLY: number;
                                const PARAM_READ_WRITE: number;
                                const PARAM_WRITE_ONLY: number;
                            }
                            export { values_1 as values };
                        }
                        namespace ObjAccessType {
                            export namespace values_2 {
                                const OBJ_READ_ONLY: number;
                                const OBJ_ADD_DELETE: number;
                                const OBJ_ADD_ONLY: number;
                                const OBJ_DELETE_ONLY: number;
                            }
                            export { values_2 as values };
                        }
                        namespace ParamValueType {
                            export namespace values_3 {
                                const PARAM_UNKNOWN: number;
                                const PARAM_BASE_64: number;
                                const PARAM_BOOLEAN: number;
                                const PARAM_DATE_TIME: number;
                                const PARAM_DECIMAL: number;
                                const PARAM_HEX_BINARY: number;
                                const PARAM_INT: number;
                                const PARAM_LONG: number;
                                const PARAM_STRING: number;
                                const PARAM_UNSIGNED_INT: number;
                                const PARAM_UNSIGNED_LONG: number;
                            }
                            export { values_3 as values };
                        }
                        namespace ValueChangeType {
                            export namespace values_4 {
                                const VALUE_CHANGE_UNKNOWN: number;
                                const VALUE_CHANGE_ALLOWED: number;
                                const VALUE_CHANGE_WILL_IGNORE: number;
                            }
                            export { values_4 as values };
                        }
                        namespace CmdType {
                            export namespace values_5 {
                                const CMD_UNKNOWN: number;
                                const CMD_SYNC: number;
                                const CMD_ASYNC: number;
                            }
                            export { values_5 as values };
                        }
                    }
                    export { nested_5 as nested };
                }
                namespace GetInstances {
                    export namespace fields_18 {
                        export namespace objPaths_1 {
                            const rule_14: string;
                            export { rule_14 as rule };
                            const type_68: string;
                            export { type_68 as type };
                            const id_68: number;
                            export { id_68 as id };
                        }
                        export { objPaths_1 as objPaths };
                        export namespace firstLevelOnly_1 {
                            const type_69: string;
                            export { type_69 as type };
                            const id_69: number;
                            export { id_69 as id };
                        }
                        export { firstLevelOnly_1 as firstLevelOnly };
                    }
                    export { fields_18 as fields };
                }
                namespace GetInstancesResp {
                    export namespace fields_19 {
                        export namespace reqPathResults_1 {
                            const rule_15: string;
                            export { rule_15 as rule };
                            const type_70: string;
                            export { type_70 as type };
                            const id_70: number;
                            export { id_70 as id };
                        }
                        export { reqPathResults_1 as reqPathResults };
                    }
                    export { fields_19 as fields };
                    export namespace nested_6 {
                        export namespace RequestedPathResult_1 {
                            export namespace fields_20 {
                                export namespace requestedPath_1 {
                                    const type_71: string;
                                    export { type_71 as type };
                                    const id_71: number;
                                    export { id_71 as id };
                                }
                                export { requestedPath_1 as requestedPath };
                                export namespace errCode_4 {
                                    const type_72: string;
                                    export { type_72 as type };
                                    const id_72: number;
                                    export { id_72 as id };
                                }
                                export { errCode_4 as errCode };
                                export namespace errMsg_4 {
                                    const type_73: string;
                                    export { type_73 as type };
                                    const id_73: number;
                                    export { id_73 as id };
                                }
                                export { errMsg_4 as errMsg };
                                export namespace currInsts {
                                    const rule_16: string;
                                    export { rule_16 as rule };
                                    const type_74: string;
                                    export { type_74 as type };
                                    const id_74: number;
                                    export { id_74 as id };
                                }
                            }
                            export { fields_20 as fields };
                        }
                        export { RequestedPathResult_1 as RequestedPathResult };
                        export namespace CurrInstance {
                            export namespace fields_21 {
                                namespace instantiatedObjPath {
                                    const type_75: string;
                                    export { type_75 as type };
                                    const id_75: number;
                                    export { id_75 as id };
                                }
                                namespace uniqueKeys {
                                    const keyType_1: string;
                                    export { keyType_1 as keyType };
                                    const type_76: string;
                                    export { type_76 as type };
                                    const id_76: number;
                                    export { id_76 as id };
                                }
                            }
                            export { fields_21 as fields };
                        }
                    }
                    export { nested_6 as nested };
                }
                namespace GetSupportedProtocol {
                    export namespace fields_22 {
                        namespace controllerSupportedProtocolVersions {
                            const type_77: string;
                            export { type_77 as type };
                            const id_77: number;
                            export { id_77 as id };
                        }
                    }
                    export { fields_22 as fields };
                }
                namespace GetSupportedProtocolResp {
                    export namespace fields_23 {
                        namespace agentSupportedProtocolVersions {
                            const type_78: string;
                            export { type_78 as type };
                            const id_78: number;
                            export { id_78 as id };
                        }
                    }
                    export { fields_23 as fields };
                }
                namespace Add {
                    export namespace fields_24 {
                        namespace allowPartial {
                            const type_79: string;
                            export { type_79 as type };
                            const id_79: number;
                            export { id_79 as id };
                        }
                        namespace createObjs {
                            const rule_17: string;
                            export { rule_17 as rule };
                            const type_80: string;
                            export { type_80 as type };
                            const id_80: number;
                            export { id_80 as id };
                        }
                    }
                    export { fields_24 as fields };
                    export namespace nested_7 {
                        namespace CreateObject {
                            export namespace fields_25 {
                                namespace objPath {
                                    const type_81: string;
                                    export { type_81 as type };
                                    const id_81: number;
                                    export { id_81 as id };
                                }
                                namespace paramSettings {
                                    const rule_18: string;
                                    export { rule_18 as rule };
                                    const type_82: string;
                                    export { type_82 as type };
                                    const id_82: number;
                                    export { id_82 as id };
                                }
                            }
                            export { fields_25 as fields };
                        }
                        namespace CreateParamSetting {
                            export namespace fields_26 {
                                namespace param {
                                    const type_83: string;
                                    export { type_83 as type };
                                    const id_83: number;
                                    export { id_83 as id };
                                }
                                namespace value {
                                    const type_84: string;
                                    export { type_84 as type };
                                    const id_84: number;
                                    export { id_84 as id };
                                }
                                namespace required {
                                    const type_85: string;
                                    export { type_85 as type };
                                    const id_85: number;
                                    export { id_85 as id };
                                }
                            }
                            export { fields_26 as fields };
                        }
                    }
                    export { nested_7 as nested };
                }
                namespace AddResp {
                    export namespace fields_27 {
                        namespace createdObjResults {
                            const rule_19: string;
                            export { rule_19 as rule };
                            const type_86: string;
                            export { type_86 as type };
                            const id_86: number;
                            export { id_86 as id };
                        }
                    }
                    export { fields_27 as fields };
                    export namespace nested_8 {
                        namespace CreatedObjectResult {
                            export namespace fields_28 {
                                export namespace requestedPath_2 {
                                    const type_87: string;
                                    export { type_87 as type };
                                    const id_87: number;
                                    export { id_87 as id };
                                }
                                export { requestedPath_2 as requestedPath };
                                export namespace operStatus {
                                    const type_88: string;
                                    export { type_88 as type };
                                    const id_88: number;
                                    export { id_88 as id };
                                }
                            }
                            export { fields_28 as fields };
                            export namespace nested_9 {
                                namespace OperationStatus {
                                    export namespace oneofs_3 {
                                        export namespace operStatus_1 {
                                            const oneof_3: string[];
                                            export { oneof_3 as oneof };
                                        }
                                        export { operStatus_1 as operStatus };
                                    }
                                    export { oneofs_3 as oneofs };
                                    export namespace fields_29 {
                                        namespace operFailure {
                                            const type_89: string;
                                            export { type_89 as type };
                                            const id_89: number;
                                            export { id_89 as id };
                                        }
                                        namespace operSuccess {
                                            const type_90: string;
                                            export { type_90 as type };
                                            const id_90: number;
                                            export { id_90 as id };
                                        }
                                    }
                                    export { fields_29 as fields };
                                    export namespace nested_10 {
                                        namespace OperationFailure {
                                            export namespace fields_30 {
                                                export namespace errCode_5 {
                                                    const type_91: string;
                                                    export { type_91 as type };
                                                    const id_91: number;
                                                    export { id_91 as id };
                                                }
                                                export { errCode_5 as errCode };
                                                export namespace errMsg_5 {
                                                    const type_92: string;
                                                    export { type_92 as type };
                                                    const id_92: number;
                                                    export { id_92 as id };
                                                }
                                                export { errMsg_5 as errMsg };
                                            }
                                            export { fields_30 as fields };
                                        }
                                        namespace OperationSuccess {
                                            export namespace fields_31 {
                                                export namespace instantiatedPath {
                                                    const type_93: string;
                                                    export { type_93 as type };
                                                    const id_93: number;
                                                    export { id_93 as id };
                                                }
                                                export namespace paramErrs_1 {
                                                    const rule_20: string;
                                                    export { rule_20 as rule };
                                                    const type_94: string;
                                                    export { type_94 as type };
                                                    const id_94: number;
                                                    export { id_94 as id };
                                                }
                                                export { paramErrs_1 as paramErrs };
                                                export namespace uniqueKeys_1 {
                                                    const keyType_2: string;
                                                    export { keyType_2 as keyType };
                                                    const type_95: string;
                                                    export { type_95 as type };
                                                    const id_95: number;
                                                    export { id_95 as id };
                                                }
                                                export { uniqueKeys_1 as uniqueKeys };
                                            }
                                            export { fields_31 as fields };
                                        }
                                    }
                                    export { nested_10 as nested };
                                }
                            }
                            export { nested_9 as nested };
                        }
                        namespace ParameterError {
                            export namespace fields_32 {
                                export namespace param_1 {
                                    const type_96: string;
                                    export { type_96 as type };
                                    const id_96: number;
                                    export { id_96 as id };
                                }
                                export { param_1 as param };
                                export namespace errCode_6 {
                                    const type_97: string;
                                    export { type_97 as type };
                                    const id_97: number;
                                    export { id_97 as id };
                                }
                                export { errCode_6 as errCode };
                                export namespace errMsg_6 {
                                    const type_98: string;
                                    export { type_98 as type };
                                    const id_98: number;
                                    export { id_98 as id };
                                }
                                export { errMsg_6 as errMsg };
                            }
                            export { fields_32 as fields };
                        }
                    }
                    export { nested_8 as nested };
                }
                namespace Delete {
                    export namespace fields_33 {
                        export namespace allowPartial_1 {
                            const type_99: string;
                            export { type_99 as type };
                            const id_99: number;
                            export { id_99 as id };
                        }
                        export { allowPartial_1 as allowPartial };
                        export namespace objPaths_2 {
                            const rule_21: string;
                            export { rule_21 as rule };
                            const type_100: string;
                            export { type_100 as type };
                            const id_100: number;
                            export { id_100 as id };
                        }
                        export { objPaths_2 as objPaths };
                    }
                    export { fields_33 as fields };
                }
                namespace DeleteResp {
                    export namespace fields_34 {
                        namespace deletedObjResults {
                            const rule_22: string;
                            export { rule_22 as rule };
                            const type_101: string;
                            export { type_101 as type };
                            const id_101: number;
                            export { id_101 as id };
                        }
                    }
                    export { fields_34 as fields };
                    export namespace nested_11 {
                        namespace DeletedObjectResult {
                            export namespace fields_35 {
                                export namespace requestedPath_3 {
                                    const type_102: string;
                                    export { type_102 as type };
                                    const id_102: number;
                                    export { id_102 as id };
                                }
                                export { requestedPath_3 as requestedPath };
                                export namespace operStatus_2 {
                                    const type_103: string;
                                    export { type_103 as type };
                                    const id_103: number;
                                    export { id_103 as id };
                                }
                                export { operStatus_2 as operStatus };
                            }
                            export { fields_35 as fields };
                            export namespace nested_12 {
                                export namespace OperationStatus_1 {
                                    export namespace oneofs_4 {
                                        export namespace operStatus_3 {
                                            const oneof_4: string[];
                                            export { oneof_4 as oneof };
                                        }
                                        export { operStatus_3 as operStatus };
                                    }
                                    export { oneofs_4 as oneofs };
                                    export namespace fields_36 {
                                        export namespace operFailure_1 {
                                            const type_104: string;
                                            export { type_104 as type };
                                            const id_104: number;
                                            export { id_104 as id };
                                        }
                                        export { operFailure_1 as operFailure };
                                        export namespace operSuccess_1 {
                                            const type_105: string;
                                            export { type_105 as type };
                                            const id_105: number;
                                            export { id_105 as id };
                                        }
                                        export { operSuccess_1 as operSuccess };
                                    }
                                    export { fields_36 as fields };
                                    export namespace nested_13 {
                                        export namespace OperationFailure_1 {
                                            export namespace fields_37 {
                                                export namespace errCode_7 {
                                                    const type_106: string;
                                                    export { type_106 as type };
                                                    const id_106: number;
                                                    export { id_106 as id };
                                                }
                                                export { errCode_7 as errCode };
                                                export namespace errMsg_7 {
                                                    const type_107: string;
                                                    export { type_107 as type };
                                                    const id_107: number;
                                                    export { id_107 as id };
                                                }
                                                export { errMsg_7 as errMsg };
                                            }
                                            export { fields_37 as fields };
                                        }
                                        export { OperationFailure_1 as OperationFailure };
                                        export namespace OperationSuccess_1 {
                                            export namespace fields_38 {
                                                namespace affectedPaths {
                                                    const rule_23: string;
                                                    export { rule_23 as rule };
                                                    const type_108: string;
                                                    export { type_108 as type };
                                                    const id_108: number;
                                                    export { id_108 as id };
                                                }
                                                namespace unaffectedPathErrs {
                                                    const rule_24: string;
                                                    export { rule_24 as rule };
                                                    const type_109: string;
                                                    export { type_109 as type };
                                                    const id_109: number;
                                                    export { id_109 as id };
                                                }
                                            }
                                            export { fields_38 as fields };
                                        }
                                        export { OperationSuccess_1 as OperationSuccess };
                                    }
                                    export { nested_13 as nested };
                                }
                                export { OperationStatus_1 as OperationStatus };
                            }
                            export { nested_12 as nested };
                        }
                        namespace UnaffectedPathError {
                            export namespace fields_39 {
                                export namespace unaffectedPath {
                                    const type_110: string;
                                    export { type_110 as type };
                                    const id_110: number;
                                    export { id_110 as id };
                                }
                                export namespace errCode_8 {
                                    const type_111: string;
                                    export { type_111 as type };
                                    const id_111: number;
                                    export { id_111 as id };
                                }
                                export { errCode_8 as errCode };
                                export namespace errMsg_8 {
                                    const type_112: string;
                                    export { type_112 as type };
                                    const id_112: number;
                                    export { id_112 as id };
                                }
                                export { errMsg_8 as errMsg };
                            }
                            export { fields_39 as fields };
                        }
                    }
                    export { nested_11 as nested };
                }
                namespace Set {
                    export namespace fields_40 {
                        export namespace allowPartial_2 {
                            const type_113: string;
                            export { type_113 as type };
                            const id_113: number;
                            export { id_113 as id };
                        }
                        export { allowPartial_2 as allowPartial };
                        export namespace updateObjs {
                            const rule_25: string;
                            export { rule_25 as rule };
                            const type_114: string;
                            export { type_114 as type };
                            const id_114: number;
                            export { id_114 as id };
                        }
                    }
                    export { fields_40 as fields };
                    export namespace nested_14 {
                        namespace UpdateObject {
                            export namespace fields_41 {
                                export namespace objPath_1 {
                                    const type_115: string;
                                    export { type_115 as type };
                                    const id_115: number;
                                    export { id_115 as id };
                                }
                                export { objPath_1 as objPath };
                                export namespace paramSettings_1 {
                                    const rule_26: string;
                                    export { rule_26 as rule };
                                    const type_116: string;
                                    export { type_116 as type };
                                    const id_116: number;
                                    export { id_116 as id };
                                }
                                export { paramSettings_1 as paramSettings };
                            }
                            export { fields_41 as fields };
                        }
                        namespace UpdateParamSetting {
                            export namespace fields_42 {
                                export namespace param_2 {
                                    const type_117: string;
                                    export { type_117 as type };
                                    const id_117: number;
                                    export { id_117 as id };
                                }
                                export { param_2 as param };
                                export namespace value_1 {
                                    const type_118: string;
                                    export { type_118 as type };
                                    const id_118: number;
                                    export { id_118 as id };
                                }
                                export { value_1 as value };
                                export namespace required_1 {
                                    const type_119: string;
                                    export { type_119 as type };
                                    const id_119: number;
                                    export { id_119 as id };
                                }
                                export { required_1 as required };
                            }
                            export { fields_42 as fields };
                        }
                    }
                    export { nested_14 as nested };
                }
                namespace SetResp {
                    export namespace fields_43 {
                        namespace updatedObjResults {
                            const rule_27: string;
                            export { rule_27 as rule };
                            const type_120: string;
                            export { type_120 as type };
                            const id_120: number;
                            export { id_120 as id };
                        }
                    }
                    export { fields_43 as fields };
                    export namespace nested_15 {
                        export namespace UpdatedObjectResult {
                            export namespace fields_44 {
                                export namespace requestedPath_4 {
                                    const type_121: string;
                                    export { type_121 as type };
                                    const id_121: number;
                                    export { id_121 as id };
                                }
                                export { requestedPath_4 as requestedPath };
                                export namespace operStatus_4 {
                                    const type_122: string;
                                    export { type_122 as type };
                                    const id_122: number;
                                    export { id_122 as id };
                                }
                                export { operStatus_4 as operStatus };
                            }
                            export { fields_44 as fields };
                            export namespace nested_16 {
                                export namespace OperationStatus_2 {
                                    export namespace oneofs_5 {
                                        export namespace operStatus_5 {
                                            const oneof_5: string[];
                                            export { oneof_5 as oneof };
                                        }
                                        export { operStatus_5 as operStatus };
                                    }
                                    export { oneofs_5 as oneofs };
                                    export namespace fields_45 {
                                        export namespace operFailure_2 {
                                            const type_123: string;
                                            export { type_123 as type };
                                            const id_123: number;
                                            export { id_123 as id };
                                        }
                                        export { operFailure_2 as operFailure };
                                        export namespace operSuccess_2 {
                                            const type_124: string;
                                            export { type_124 as type };
                                            const id_124: number;
                                            export { id_124 as id };
                                        }
                                        export { operSuccess_2 as operSuccess };
                                    }
                                    export { fields_45 as fields };
                                    export namespace nested_17 {
                                        export namespace OperationFailure_2 {
                                            export namespace fields_46 {
                                                export namespace errCode_9 {
                                                    const type_125: string;
                                                    export { type_125 as type };
                                                    const id_125: number;
                                                    export { id_125 as id };
                                                }
                                                export { errCode_9 as errCode };
                                                export namespace errMsg_9 {
                                                    const type_126: string;
                                                    export { type_126 as type };
                                                    const id_126: number;
                                                    export { id_126 as id };
                                                }
                                                export { errMsg_9 as errMsg };
                                                export namespace updatedInstFailures {
                                                    const rule_28: string;
                                                    export { rule_28 as rule };
                                                    const type_127: string;
                                                    export { type_127 as type };
                                                    const id_127: number;
                                                    export { id_127 as id };
                                                }
                                            }
                                            export { fields_46 as fields };
                                        }
                                        export { OperationFailure_2 as OperationFailure };
                                        export namespace OperationSuccess_2 {
                                            export namespace fields_47 {
                                                namespace updatedInstResults {
                                                    const rule_29: string;
                                                    export { rule_29 as rule };
                                                    const type_128: string;
                                                    export { type_128 as type };
                                                    const id_128: number;
                                                    export { id_128 as id };
                                                }
                                            }
                                            export { fields_47 as fields };
                                        }
                                        export { OperationSuccess_2 as OperationSuccess };
                                    }
                                    export { nested_17 as nested };
                                }
                                export { OperationStatus_2 as OperationStatus };
                            }
                            export { nested_16 as nested };
                        }
                        export namespace UpdatedInstanceFailure {
                            export namespace fields_48 {
                                export namespace affectedPath {
                                    const type_129: string;
                                    export { type_129 as type };
                                    const id_129: number;
                                    export { id_129 as id };
                                }
                                export namespace paramErrs_2 {
                                    const rule_30: string;
                                    export { rule_30 as rule };
                                    const type_130: string;
                                    export { type_130 as type };
                                    const id_130: number;
                                    export { id_130 as id };
                                }
                                export { paramErrs_2 as paramErrs };
                            }
                            export { fields_48 as fields };
                        }
                        export namespace UpdatedInstanceResult {
                            export namespace fields_49 {
                                export namespace affectedPath_1 {
                                    const type_131: string;
                                    export { type_131 as type };
                                    const id_131: number;
                                    export { id_131 as id };
                                }
                                export { affectedPath_1 as affectedPath };
                                export namespace paramErrs_3 {
                                    const rule_31: string;
                                    export { rule_31 as rule };
                                    const type_132: string;
                                    export { type_132 as type };
                                    const id_132: number;
                                    export { id_132 as id };
                                }
                                export { paramErrs_3 as paramErrs };
                                export namespace updatedParams {
                                    const keyType_3: string;
                                    export { keyType_3 as keyType };
                                    const type_133: string;
                                    export { type_133 as type };
                                    const id_133: number;
                                    export { id_133 as id };
                                }
                            }
                            export { fields_49 as fields };
                        }
                        export namespace ParameterError_1 {
                            export namespace fields_50 {
                                export namespace param_3 {
                                    const type_134: string;
                                    export { type_134 as type };
                                    const id_134: number;
                                    export { id_134 as id };
                                }
                                export { param_3 as param };
                                export namespace errCode_10 {
                                    const type_135: string;
                                    export { type_135 as type };
                                    const id_135: number;
                                    export { id_135 as id };
                                }
                                export { errCode_10 as errCode };
                                export namespace errMsg_10 {
                                    const type_136: string;
                                    export { type_136 as type };
                                    const id_136: number;
                                    export { id_136 as id };
                                }
                                export { errMsg_10 as errMsg };
                            }
                            export { fields_50 as fields };
                        }
                        export { ParameterError_1 as ParameterError };
                    }
                    export { nested_15 as nested };
                }
                namespace Operate {
                    export namespace fields_51 {
                        namespace command {
                            const type_137: string;
                            export { type_137 as type };
                            const id_137: number;
                            export { id_137 as id };
                        }
                        namespace commandKey {
                            const type_138: string;
                            export { type_138 as type };
                            const id_138: number;
                            export { id_138 as id };
                        }
                        namespace sendResp {
                            const type_139: string;
                            export { type_139 as type };
                            const id_139: number;
                            export { id_139 as id };
                        }
                        namespace inputArgs {
                            const keyType_4: string;
                            export { keyType_4 as keyType };
                            const type_140: string;
                            export { type_140 as type };
                            const id_140: number;
                            export { id_140 as id };
                        }
                    }
                    export { fields_51 as fields };
                }
                namespace OperateResp {
                    export namespace fields_52 {
                        namespace operationResults {
                            const rule_32: string;
                            export { rule_32 as rule };
                            const type_141: string;
                            export { type_141 as type };
                            const id_141: number;
                            export { id_141 as id };
                        }
                    }
                    export { fields_52 as fields };
                    export namespace nested_18 {
                        namespace OperationResult {
                            export namespace oneofs_6 {
                                namespace operationResp {
                                    const oneof_6: string[];
                                    export { oneof_6 as oneof };
                                }
                            }
                            export { oneofs_6 as oneofs };
                            export namespace fields_53 {
                                export namespace executedCommand {
                                    const type_142: string;
                                    export { type_142 as type };
                                    const id_142: number;
                                    export { id_142 as id };
                                }
                                export namespace reqObjPath_1 {
                                    const type_143: string;
                                    export { type_143 as type };
                                    const id_143: number;
                                    export { id_143 as id };
                                }
                                export { reqObjPath_1 as reqObjPath };
                                export namespace reqOutputArgs {
                                    const type_144: string;
                                    export { type_144 as type };
                                    const id_144: number;
                                    export { id_144 as id };
                                }
                                export namespace cmdFailure {
                                    const type_145: string;
                                    export { type_145 as type };
                                    const id_145: number;
                                    export { id_145 as id };
                                }
                            }
                            export { fields_53 as fields };
                            export namespace nested_19 {
                                namespace OutputArgs {
                                    export namespace fields_54 {
                                        namespace outputArgs {
                                            const keyType_5: string;
                                            export { keyType_5 as keyType };
                                            const type_146: string;
                                            export { type_146 as type };
                                            const id_146: number;
                                            export { id_146 as id };
                                        }
                                    }
                                    export { fields_54 as fields };
                                }
                                namespace CommandFailure {
                                    export namespace fields_55 {
                                        export namespace errCode_11 {
                                            const type_147: string;
                                            export { type_147 as type };
                                            const id_147: number;
                                            export { id_147 as id };
                                        }
                                        export { errCode_11 as errCode };
                                        export namespace errMsg_11 {
                                            const type_148: string;
                                            export { type_148 as type };
                                            const id_148: number;
                                            export { id_148 as id };
                                        }
                                        export { errMsg_11 as errMsg };
                                    }
                                    export { fields_55 as fields };
                                }
                            }
                            export { nested_19 as nested };
                        }
                    }
                    export { nested_18 as nested };
                }
                namespace Notify {
                    export namespace oneofs_7 {
                        namespace notification {
                            const oneof_7: string[];
                            export { oneof_7 as oneof };
                        }
                    }
                    export { oneofs_7 as oneofs };
                    export namespace fields_56 {
                        export namespace subscriptionId {
                            const type_149: string;
                            export { type_149 as type };
                            const id_149: number;
                            export { id_149 as id };
                        }
                        export namespace sendResp_1 {
                            const type_150: string;
                            export { type_150 as type };
                            const id_150: number;
                            export { id_150 as id };
                        }
                        export { sendResp_1 as sendResp };
                        export namespace event {
                            const type_151: string;
                            export { type_151 as type };
                            const id_151: number;
                            export { id_151 as id };
                        }
                        export namespace valueChange_1 {
                            const type_152: string;
                            export { type_152 as type };
                            const id_152: number;
                            export { id_152 as id };
                        }
                        export { valueChange_1 as valueChange };
                        export namespace objCreation {
                            const type_153: string;
                            export { type_153 as type };
                            const id_153: number;
                            export { id_153 as id };
                        }
                        export namespace objDeletion {
                            const type_154: string;
                            export { type_154 as type };
                            const id_154: number;
                            export { id_154 as id };
                        }
                        export namespace operComplete {
                            const type_155: string;
                            export { type_155 as type };
                            const id_155: number;
                            export { id_155 as id };
                        }
                        export namespace onBoardReq {
                            const type_156: string;
                            export { type_156 as type };
                            const id_156: number;
                            export { id_156 as id };
                        }
                    }
                    export { fields_56 as fields };
                    export namespace nested_20 {
                        namespace Event {
                            export namespace fields_57 {
                                export namespace objPath_2 {
                                    const type_157: string;
                                    export { type_157 as type };
                                    const id_157: number;
                                    export { id_157 as id };
                                }
                                export { objPath_2 as objPath };
                                export namespace eventName_1 {
                                    const type_158: string;
                                    export { type_158 as type };
                                    const id_158: number;
                                    export { id_158 as id };
                                }
                                export { eventName_1 as eventName };
                                export namespace params {
                                    const keyType_6: string;
                                    export { keyType_6 as keyType };
                                    const type_159: string;
                                    export { type_159 as type };
                                    const id_159: number;
                                    export { id_159 as id };
                                }
                            }
                            export { fields_57 as fields };
                        }
                        namespace ValueChange {
                            export namespace fields_58 {
                                export namespace paramPath_1 {
                                    const type_160: string;
                                    export { type_160 as type };
                                    const id_160: number;
                                    export { id_160 as id };
                                }
                                export { paramPath_1 as paramPath };
                                export namespace paramValue {
                                    const type_161: string;
                                    export { type_161 as type };
                                    const id_161: number;
                                    export { id_161 as id };
                                }
                            }
                            export { fields_58 as fields };
                        }
                        namespace ObjectCreation {
                            export namespace fields_59 {
                                export namespace objPath_3 {
                                    const type_162: string;
                                    export { type_162 as type };
                                    const id_162: number;
                                    export { id_162 as id };
                                }
                                export { objPath_3 as objPath };
                                export namespace uniqueKeys_2 {
                                    const keyType_7: string;
                                    export { keyType_7 as keyType };
                                    const type_163: string;
                                    export { type_163 as type };
                                    const id_163: number;
                                    export { id_163 as id };
                                }
                                export { uniqueKeys_2 as uniqueKeys };
                            }
                            export { fields_59 as fields };
                        }
                        namespace ObjectDeletion {
                            export namespace fields_60 {
                                export namespace objPath_4 {
                                    const type_164: string;
                                    export { type_164 as type };
                                    const id_164: number;
                                    export { id_164 as id };
                                }
                                export { objPath_4 as objPath };
                            }
                            export { fields_60 as fields };
                        }
                        namespace OperationComplete {
                            export namespace oneofs_8 {
                                export namespace operationResp_1 {
                                    const oneof_8: string[];
                                    export { oneof_8 as oneof };
                                }
                                export { operationResp_1 as operationResp };
                            }
                            export { oneofs_8 as oneofs };
                            export namespace fields_61 {
                                export namespace objPath_5 {
                                    const type_165: string;
                                    export { type_165 as type };
                                    const id_165: number;
                                    export { id_165 as id };
                                }
                                export { objPath_5 as objPath };
                                export namespace commandName_1 {
                                    const type_166: string;
                                    export { type_166 as type };
                                    const id_166: number;
                                    export { id_166 as id };
                                }
                                export { commandName_1 as commandName };
                                export namespace commandKey_1 {
                                    const type_167: string;
                                    export { type_167 as type };
                                    const id_167: number;
                                    export { id_167 as id };
                                }
                                export { commandKey_1 as commandKey };
                                export namespace reqOutputArgs_1 {
                                    const type_168: string;
                                    export { type_168 as type };
                                    const id_168: number;
                                    export { id_168 as id };
                                }
                                export { reqOutputArgs_1 as reqOutputArgs };
                                export namespace cmdFailure_1 {
                                    const type_169: string;
                                    export { type_169 as type };
                                    const id_169: number;
                                    export { id_169 as id };
                                }
                                export { cmdFailure_1 as cmdFailure };
                            }
                            export { fields_61 as fields };
                            export namespace nested_21 {
                                export namespace OutputArgs_1 {
                                    export namespace fields_62 {
                                        export namespace outputArgs_1 {
                                            const keyType_8: string;
                                            export { keyType_8 as keyType };
                                            const type_170: string;
                                            export { type_170 as type };
                                            const id_170: number;
                                            export { id_170 as id };
                                        }
                                        export { outputArgs_1 as outputArgs };
                                    }
                                    export { fields_62 as fields };
                                }
                                export { OutputArgs_1 as OutputArgs };
                                export namespace CommandFailure_1 {
                                    export namespace fields_63 {
                                        export namespace errCode_12 {
                                            const type_171: string;
                                            export { type_171 as type };
                                            const id_171: number;
                                            export { id_171 as id };
                                        }
                                        export { errCode_12 as errCode };
                                        export namespace errMsg_12 {
                                            const type_172: string;
                                            export { type_172 as type };
                                            const id_172: number;
                                            export { id_172 as id };
                                        }
                                        export { errMsg_12 as errMsg };
                                    }
                                    export { fields_63 as fields };
                                }
                                export { CommandFailure_1 as CommandFailure };
                            }
                            export { nested_21 as nested };
                        }
                        namespace OnBoardRequest {
                            export namespace fields_64 {
                                export namespace oui {
                                    const type_173: string;
                                    export { type_173 as type };
                                    const id_173: number;
                                    export { id_173 as id };
                                }
                                export namespace productClass {
                                    const type_174: string;
                                    export { type_174 as type };
                                    const id_174: number;
                                    export { id_174 as id };
                                }
                                export namespace serialNumber {
                                    const type_175: string;
                                    export { type_175 as type };
                                    const id_175: number;
                                    export { id_175 as id };
                                }
                                export namespace agentSupportedProtocolVersions_1 {
                                    const type_176: string;
                                    export { type_176 as type };
                                    const id_176: number;
                                    export { id_176 as id };
                                }
                                export { agentSupportedProtocolVersions_1 as agentSupportedProtocolVersions };
                            }
                            export { fields_64 as fields };
                        }
                    }
                    export { nested_20 as nested };
                }
                namespace NotifyResp {
                    export namespace fields_65 {
                        export namespace subscriptionId_1 {
                            const type_177: string;
                            export { type_177 as type };
                            const id_177: number;
                            export { id_177 as id };
                        }
                        export { subscriptionId_1 as subscriptionId };
                    }
                    export { fields_65 as fields };
                }
            }
            export { nested_1 as nested };
        }
    }
}
export default _default;
