declare namespace _default {
    namespace nested {
        namespace usp_record {
            export namespace nested_1 {
                namespace Record {
                    export namespace oneofs {
                        namespace recordType {
                            const oneof: string[];
                        }
                    }
                    export namespace fields {
                        namespace version {
                            const type: string;
                            const id: number;
                        }
                        namespace toId {
                            const type_1: string;
                            export { type_1 as type };
                            const id_1: number;
                            export { id_1 as id };
                        }
                        namespace fromId {
                            const type_2: string;
                            export { type_2 as type };
                            const id_2: number;
                            export { id_2 as id };
                        }
                        namespace payloadSecurity {
                            const type_3: string;
                            export { type_3 as type };
                            const id_3: number;
                            export { id_3 as id };
                        }
                        namespace macSignature {
                            const type_4: string;
                            export { type_4 as type };
                            const id_4: number;
                            export { id_4 as id };
                        }
                        namespace senderCert {
                            const type_5: string;
                            export { type_5 as type };
                            const id_5: number;
                            export { id_5 as id };
                        }
                        namespace noSessionContext {
                            const type_6: string;
                            export { type_6 as type };
                            const id_6: number;
                            export { id_6 as id };
                        }
                        namespace sessionContext {
                            const type_7: string;
                            export { type_7 as type };
                            const id_7: number;
                            export { id_7 as id };
                        }
                    }
                    export namespace nested_2 {
                        namespace PayloadSecurity {
                            namespace values {
                                const PLAINTEXT: number;
                                const TLS12: number;
                            }
                        }
                    }
                    export { nested_2 as nested };
                }
                namespace NoSessionContextRecord {
                    export namespace fields_1 {
                        namespace payload {
                            const type_8: string;
                            export { type_8 as type };
                            const id_8: number;
                            export { id_8 as id };
                        }
                    }
                    export { fields_1 as fields };
                }
                namespace SessionContextRecord {
                    export namespace fields_2 {
                        export namespace sessionId {
                            const type_9: string;
                            export { type_9 as type };
                            const id_9: number;
                            export { id_9 as id };
                        }
                        export namespace sequenceId {
                            const type_10: string;
                            export { type_10 as type };
                            const id_10: number;
                            export { id_10 as id };
                        }
                        export namespace expectedId {
                            const type_11: string;
                            export { type_11 as type };
                            const id_11: number;
                            export { id_11 as id };
                        }
                        export namespace retransmitId {
                            const type_12: string;
                            export { type_12 as type };
                            const id_12: number;
                            export { id_12 as id };
                        }
                        export namespace payloadSarState {
                            const type_13: string;
                            export { type_13 as type };
                            const id_13: number;
                            export { id_13 as id };
                        }
                        export namespace payloadrecSarState {
                            const type_14: string;
                            export { type_14 as type };
                            const id_14: number;
                            export { id_14 as id };
                        }
                        export namespace payload_1 {
                            export const rule: string;
                            const type_15: string;
                            export { type_15 as type };
                            const id_15: number;
                            export { id_15 as id };
                        }
                        export { payload_1 as payload };
                    }
                    export { fields_2 as fields };
                    export namespace nested_3 {
                        namespace PayloadSARState {
                            export namespace values_1 {
                                const NONE: number;
                                const BEGIN: number;
                                const INPROCESS: number;
                                const COMPLETE: number;
                            }
                            export { values_1 as values };
                        }
                    }
                    export { nested_3 as nested };
                }
            }
            export { nested_1 as nested };
        }
    }
}
export default _default;
