import { CallbackOptions, CommandType, OnCallback, OnIdent } from "./types";
/**
 * Makes a router for storing resolve/reject for a message
 */
export declare const makeRouter: () => {
    get: (id: string, cmd: CommandType) => any;
    add: (id: string, cmd: CommandType, data: any) => void;
};
export declare const makeCallbackRouter: () => {
    get: (id: string) => OnCallback[];
    add: (ident: OnIdent, callback: OnCallback) => void;
    del: (id: OnIdent) => boolean;
};
export declare const parseCallbackOptions: (msg: Record<string, any>) => CallbackOptions | null;
export declare const knownUSPVersions: readonly ["1.0", "1.1", "1.2"];
